Subject: RE: Comments on draft-ietf-rtgwg-cl-requirement-01

From: "Mcdysan, David E" <[email-masked]>
Date: Wed, 1 Sep 2010 09:50:58 -0400

Hi Tony,

Thanks for the careful and thoughtful review.

Some responses in line below.

Thanks,

Dave 

> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]] 
> On Behalf Of Tony Li
> Sent: Wednesday, August 25, 2010 7:40 PM
> To: [email-masked]
> Subject: Comments on draft-ietf-rtgwg-cl-requirement-01
> 
> 
> Hi all,
> 
> Here's some comments on the current version of the draft, 
> through section 4.3:
> 
> - The draft needs some proofreading.  I'll pass some 
> editorial comments along to the editors separately.  More 
> proofing is probably required.  More help would be most welcome.

Thanks for these comments, I will incorporate them and in some cases have proposed revised text for your review/comment where you believed the intent was unclear.

> 
> - In the definition of composite link, the intent here is 
> still slightly unclear.  Are we defining a composite link to 
> be either a "Multiple Parallel Link" or a "Multi-layer 
> Component Link"?  

Yes.

> 
> - Aren't all component links inherently multi-layer?  Don't 
> they all have a physical and logical layer?  What's the 
> purpose of defining a multi-layer component link?

The interesting case is when the lower layer network elements can dynamically change the characteristics of the component link as seen by the MPLS routers. I will add this clarification.

> 
> - In the definition of a component link, do we want to say 
> anything about atomicity?  Sequentiality?
> 

Not sure what you mean here. We had dropped the word atomic (it is still in the abstract) and sequentiality could be interpreted as another word for in order (see below).

> - In the definition of a flow, isn't the defining property 
> that it must remain ordered?  We maintain that ordering by 
> constraining them to a sequential link.

Propose adding IN ORDER to the definition as follows.

Flow:  A sequence of packets that must be transferred IN ORDER on one component link.

> 
> - Section 4.1, FR#1: Since SLAs are sometimes confidential 
> and generally inconsistent, do we really want to define our 
> requirements in terms of them?  Don't we just mean a provider 
> specified service level?  Same comment in FR#5 and elsewhere.
> 

The first paragraph of Appendix A provides some references for the components of an SLA as well as bounds on numerical values for these items when considering multiple interconnected networks (i.e., ITU-T Y.1541). Not sure what you mean by "provider specified service level" and how this would differ from terms defined in the cited references. 

For clarity, we could add a SLA objectives term in the definitions section that would summarize and repeat some of the cited references in Appendix A. 

We did discuss this briefly in Maastricht (see the comment by John and my response). I also recall mentioning your comments on the list regarding wanting to state these in terms of numerical values, of not only SLA objectives, but parameters that would describe the network as well. 

This is a challenging area to specify in a public domain standard. One thought that occurs to me is to say that the SLA objective targets should be based upon Y.1541 for O(10) interconnected networks. I also plan to add Y.1540 for the definition of availability as referenced in Y.1541 to make access to this definition less indirect.

> - Section 4.1, FR#2: In the worst case, when a cross-section 
> of the network fails, doesn't the network end up being 
> disconnected?  How is restoration supposed to work?  I 
> suspect the intent here was something different.

Good catch. How is this rewording?

The solution SHALL provide a means for aggregating signaling such that in response to a failure in the worst case cross section of the network WHICH DOES NOT PARTITION THE NETWORK that MPLS LSPs are restored within the timeframe needed to meet the SLA objective.

> 
> Regards,
> Tony
> 
> _______________________________________________
> rtgwg mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/rtgwg
>

---

From: Tony Li <[email-masked]>
Date: Wed, 1 Sep 2010 18:37:49 -0700

Hi Dave,

>> be either a "Multiple Parallel Link" or a "Multi-layer 

Ok, this is not blindingly obvious, IMHO.

> Not sure what you mean here. We had dropped the word atomic (it is still in the abstract) and sequentiality could be interpreted as another word for in order (see below).

I'm trying to distinguish between component links and other types of links.  One way of doing this is to talk about particular properties, especially for logical links.  Can a composite link itself be a component link for a higher order composite?   Could a logical tunnel that did not provide ordering be used as a component link?  Do packets on a component link necessarily take the same bottom layer physical path?

> Flow:  A sequence of packets that must be transferred IN ORDER on one component link.

Good, but isn't "on one component link" then redundant?  That's just how we maintain ordering, yes?

> The first paragraph of Appendix A provides some references for the components of an SLA as well as bounds on numerical values for these items when considering multiple interconnected networks (i.e.…

Perhaps I'm being pedantic, but an SLA is a contractual agreement.  A provider is going to have a varying set of these that we won't be privy to.  It would seem more concrete to make our definitions against something like what RFC 3809 refers to as a Service Level Specification (SLS).

> The solution SHALL provide a means for aggregating signaling such that in response to a failure in the worst case cross section of the network WHICH DOES NOT PARTITION THE NETWORK that MPLS LSPs ar…

Seems like you could still have failures that prevented full restoration without a partition, yes?   Find a cut set of the graph.  Measure traffic to level L.  Cut enough links along the cut set so that the remaining edges have less than L.

Are you trying to avoid signaling collapse?  Or just asking that restoration happen within the SLS?

Tony

---

From: "Mcdysan, David E" <[email-masked]>
Date: Thu, 2 Sep 2010 10:00:56 -0400

Hi Tony,

Good comments.

Responses in line below, attempting to result in acceptable, clearly stated requirements text.

Thanks,

Dave 

> From: Tony Li [mailto:[email-masked]] 
> Sent: Wednesday, September 01, 2010 9:38 PM
> To: Mcdysan, David E
> Cc: [email-masked]
> Subject: Re: Comments on draft-ietf-rtgwg-cl-requirement-01
> 
> 
> Hi Dave,
> 
> >> - In the definition of composite link, the intent here is still 
> >> slightly unclear.  Are we defining a composite link to be either a 
> >> "Multiple Parallel Link" or a "Multi-layer Component Link"?
> > 
> > Yes.
> 
> 

Does adding the phrase "to be either a "Multiple Parallel Link" or a "Multi-layer Component Link" to the Definition in section 3 help? We had revised the document to not include ITU-T terms in the body and possibly summarized the fact the the term "composite link" has multiple meanings (we exclude the inverse multiplexing meaning).

   Composite Link:
       Section 6.9.2 of ITU-T-G.800 [ITU-T.G.800] defines composite link
       as summarized in Appendix C to be either the case of "Multiple Parallel Links" and/or a "Multi-layer Component Link".  The following definitions map the ITU-T G.800 terminology into IETF 	terminology which is used in this document.

       Multiple parallel links:  When multiple parallel component links
           between the an LER/LSR and another LER/LSR.

       Multi-layer Component Link:  A component link that is formed by
           other network elements at other layers.

> > Not sure what you mean here. We had dropped the word atomic 
> (it is still in the abstract) and sequentiality could be 
> interpreted as another word for in order (see below).
> 
> 
> I'm trying to distinguish between component links and other 
> types of links.  One way of doing this is to talk about 
> particular properties, especially for logical links.  Can a 
> composite link itself be a component link for a higher order 
> composite?   

We had not explicitly specified this case, but the form of recursion you mention is certainly possible and has at least one potential operator use case. For example, a "composite link" of MPLS-TP bi-directional tunnels viewed as logical links, which is then used as a component link in yet another "composite link" that connects MPLS routers. 

This type of usage should definitely be considered in a solution. I recommend adding a desirable requirement along the following lines. (Proposed rewording for clarification is invited.)

The solution SHOULD support the use case where a composite link itself is a component link for a higher order composite link. For example, a "composite link" of MPLS-TP bi-directional tunnels viewed as logical linkscould then be used as a component link in yet another "composite link" that connects MPLS routers. 

> Could a logical tunnel that did not provide 
> ordering be used as a component link?  

IMHO, No. Propose revising the definition of component link to exclude this case as follows.

Component Link:  A physical link (e.g., Lambda, Ethernet PHY, SONET/
       SDH, OTN, etc.) with packet transport capability, or a logical
       link (e.g., MPLS LSP, Ethernet VLAN, MPLS-TP LSP, etc.) THAT IN THE STEADY STATE PRESVERSE PACKET ORDERING. (NOTE THAT THE FREQUENCY OF TRANSIENT OUT OF ORDERING EVENTS (E.G., SWITCHING FROM A LONGER PATH TO A SHORTER ONE) MAY BE ACCEPTABLE FOR CERTAIN SETS OF FLOWS AS SPECIFIED IN THIS DOCUMENT).

> Do packets on a 
> component link necessarily take the same bottom layer physical path?

I can think of solution class where they do not, that is the inverse multiplexing scenario from ITU-T G.800 composite link.  Other solution classes may be possible. Not sure if there is a new requirement here, or if this is an attribute of a solution.

> 
> 
> >> - In the definition of a flow, isn't the defining property that it 
> >> must remain ordered?  We maintain that ordering by 
> constraining them 
> >> to a sequential link.
> > 
> Good, but isn't "on one component link" then redundant?  
> That's just how we maintain ordering, yes?

Agreed. Sometimes redundancy adds clarity, and that is all I was trying to do in this simple rewording.

> 
> 
> >> - Section 4.1, FR#1: Since SLAs are sometimes confidential and 
> >> generally inconsistent, do we really want to define our 
> requirements 
> >> in terms of them?  Don't we just mean a provider specified service 
> >> level?  Same comment in FR#5 and elsewhere.
> > 
> > The first paragraph of Appendix A provides some references 
> for the components of an SLA as well as bounds on numerical 
> values for these items when considering multiple 
> interconnected networks (i.e., ITU-T Y.1541). Not sure what 
> you mean by "provider specified service level" and how this 
> would differ from terms defined in the cited references. 
> 
> 
> Perhaps I'm being pedantic, but an SLA is a contractual 
> agreement.  A provider is going to have a varying set of 
> these that we won't be privy to.  It would seem more concrete 
> to make our definitions against something like what RFC 3809 
> refers to as a Service Level Specification (SLS).

SLS's are often an internal service provider objectives that are not communicated to customers, so in a sense they are even more proprietary than an SLA. Suggest that we use the ITU-T Y.1541 terminology of "Network Performance Objective" instead of SLA (or SLS). 

> 
> 
> >> - Section 4.1, FR#2: In the worst case, when a 
> cross-section of the 
> >> network fails, doesn't the network end up being 
> disconnected?  How is 
> >> restoration supposed to work?  I suspect the intent here was 
> >> something different.
> > 
> > The solution SHALL provide a means for aggregating 
> signaling such that in response to a failure in the worst 
> case cross section of the network WHICH DOES NOT PARTITION 
> THE NETWORK that MPLS LSPs are restored within the timeframe 
> needed to meet the SLA objective.
> 
> 
> Seems like you could still have failures that prevented full 
> restoration without a partition, yes?   Find a cut set of the 
> graph.  Measure traffic to level L.  Cut enough links along 
> the cut set so that the remaining edges have less than L.
> 

Just asking that restoration happen within the network performance objective of restoration time.

Does the following text address your comments?

The solution SHALL provide a means for aggregating signaling such that in response to a failure in the worst case cross section of the network WHICH DOES NOT PARTITION THE NETWORK AND RESULTS IN SUFFICIENT CAPACITY FOR RESTORING ALL LSPS, such that ALL MPLS LSPs are restored within the timeframe needed to meet the NETWORK PERFORMANCE objective.

---

From: Tony Li <[email-masked]>
Date: Fri, 3 Sep 2010 14:54:25 -0700

Hi Dave,

More comments below...

>>>> - In the definition of composite link, ...
> 

This is better, thanks.  Let me propose some alternate wordsmithing.  Take whatever you like, leave the rest.  ;-)

	Composite Link:
		A composite link is a logical link composed of a set of parallel 
		point-to-point component links, where all links in the set share the 
		same endpoints.  A composite link may itself be a component of another 
		composite link, but only a strict hierarchy of links is allowed.
		
	Component Link:
		A point-to-point physical or logical link that preserves ordering in the 
		steady state.  A component link may have transient out of order events, 
		but such events must not exceed the network's specific Network 
		Performance Objective (NPO).   

	These definitions are derived from and intended to be consistent with 
	Section 6.9.2 of ITU-T-G.800 [ITU-T.G.800] and are summarized in 
	Appendix C.

> SLS's are often an internal service provider objectives that are not communicated to customers, so in a sense they are even more proprietary than an SLA. Suggest that we use the ITU-T Y.1541 termin…

Works for me, thanks.

> The solution SHALL provide a means for aggregating signaling such that in response to a failure in the worst case cross section of the network WHICH DOES NOT PARTITION THE NETWORK AND RESULTS IN SU…

Let me offer more wordsmithing for your consideration:

The solution SHALL ensure that all possible restoration operations happen within the timeframe needed to meet the NPO.  The solution may need to specify a means for aggregating signaling to meet this requirement.

Regards,
Tony